package {
	import com.sociodox.theminer.TheMiner;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.utils.setTimeout;
	import gert.Game;
	import jrlib.util.KeyboardUtil;
	
	/**
	 * ...
	 * @author Jesse Ringrose
	 */
	public class Main extends Sprite {
		
		public static const SKIP_INTRO:Boolean = false;
		public static const ENABLE_DEBUG:Boolean = false;
		public static const STARTING_LEVEL:Class = Level1;
		
		//public static const SKIP_INTRO:Boolean = true;
		//public static const ENABLE_DEBUG:Boolean = true;
		//public static const STARTING_LEVEL:Class = Level11;
		
		
		private var g:Game;
		
		public function Main():void {
			//addChild(new TheMiner());
			
			if (stage) onAddedStage();
			else addEventListener(Event.ADDED_TO_STAGE, onAddedStage);
		}
		
		private function onAddedStage(e:Event = null):void {
			removeEventListener(Event.ADDED_TO_STAGE, onAddedStage);
			addEventListener(Event.ENTER_FRAME, onDelayedInit);
		}
		
		private function onDelayedInit(e:Event):void {
			removeEventListener(Event.ENTER_FRAME, onDelayedInit);
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			
			init();
		}
		
		private function init():void {
			addChild(new KeyboardUtil());
			g = new Game(stage);
			
			if (SKIP_INTRO) {
				setTimeout(function():void { 
					beginGame();
				}, 0);
			} else {
				var title:MovieClip = new MainTitle();
				title.addFrameScript(title.totalFrames - 1, function():void {
					title.gotoAndStop(1);
					title.parent.removeChild(title);
					beginGame();
				});
				title.play();
				stage.addChild(title);
			}
		}
		
		private function beginGame():void {
			g.currentLevelIndex = 0;
			for (var i:int = 0; i < Game.LEVELS.length; i++ ) {
				if (Game.LEVELS[i] is STARTING_LEVEL) {
					g.currentLevelIndex = i;
				}
			}
			g.startLevel();
		}
		
		private function onEnterFrame(e:Event):void {
			g.update();
		}
		
	}
	
}