package gert {
	import Box2D.Collision.b2ContactID;
	import Box2D.Collision.b2Manifold;
	import Box2D.Collision.b2ManifoldPoint;
	import Box2D.Collision.b2WorldManifold;
	import Box2D.Common.Math.b2Vec2;
	import Box2D.Dynamics.b2Body;
	import Box2D.Dynamics.b2ContactListener;
	import Box2D.Dynamics.Contacts.b2Contact;
	import gert.Game;
	import jrlib.util.Box2DUtil;


	public class ContactListener extends b2ContactListener {
		private var level:Level;
		private var worldManifold:b2WorldManifold = new b2WorldManifold();
		
		public function ContactListener(level:Level) {
			this.level = level;
		}
		
		override public function BeginContact(contact:b2Contact):void {
			
		}
		
		override public function PreSolve(contact:b2Contact, oldManifold:b2Manifold):void {
			//trace("presolve contact");
			var bodyA:b2Body = contact.GetFixtureA().GetBody();
			var bodyB:b2Body = contact.GetFixtureB().GetBody();
			
			//contact = bodyA.GetContactList().contact;
			
			// if wall-sound collision... leave a mark.
			worldManifold = new b2WorldManifold();
			contact.GetWorldManifold(worldManifold);
			
			var soundWave:SoundWave;
			if (bodyA.GetUserData() is SoundWave)
				soundWave = bodyA.GetUserData();
			if (bodyB.GetUserData() is SoundWave)
				soundWave = bodyB.GetUserData();
				
			if (!soundWave) 
				return;
				
			var x:Number;
			var y:Number;
			var alpha:Number;
			
			var worldPt:b2Vec2 = worldManifold.m_points[0].Copy();
			x = worldPt.x;
			y = worldPt.y;
			alpha = soundWave.lifetime / soundWave.startLifetime + 0.3;
			
			// uncomment to make it draw
			/*level.lineGraphics.lineStyle();
			level.lineGraphics.beginFill(0xFFFFFF, alpha);
			level.lineGraphics.drawCircle(x * Box2DUtil.SCALING_FACTOR, y * Box2DUtil.SCALING_FACTOR, 1);
			level.lineGraphics.endFill();
			*/
		}
		
	}
}