package gert {
	import Box2D.Common.Math.b2Vec2;
	import Box2D.Dynamics.b2Body;
	import Box2D.Dynamics.b2FilterData;
	import flash.geom.Point;
	import jrlib.util.Box2DUtil;
	import jrlib.util.MathUtil;
	
	/**
	 * ...
	 * @author Jesse Ringrose
	 */
	public class Enemy {
		
		public static const SIZE:Number = 23;
		public static const SPEED:Number = 1.2;
		
		private var game:Game;
		
		private var body:b2Body;
		public var pos:Point;
		
		public var targetX:Number = 0;
		public var targetY:Number = 0;
		
		public var footstepCounter:Number = 0;
		
		public function Enemy(game:Game, pos:Point) {
			this.pos = pos;
			this.game = game;
			
			targetX = pos.x;
			targetY = pos.y;
			
			//body = Box2DUtil.createBox(game.level.m_world, 20, 20, pos.x, pos.y, true, true, 10, 0.5, 0.2);
			
			
			
			//body.SetUserData(this);
		}
		
		public function isInRect(x:Number, y:Number):Boolean {
			if (x >= pos.x - SIZE && x <= pos.x + SIZE && y >= pos.y - SIZE && y <= pos.y + SIZE) {
				return true;
			}
			return false;
		}
		
		public function update(deltaT:Number):void {
			// if hit by noise, rotate and move towards noise for a while.
			//body.SetAngularVelocity(0.5);
			
			// move towards target position
			var dx:Number = targetX - pos.x;
			var dy:Number = targetY - pos.y;
			
			if (dx == 0 && dy == 0)
				return;
			
			var angle:Number = Math.atan2(dy, dx);
			var dist:Number = MathUtil.distanceBetween(0, 0, dx, dy);
			
			pos.x += Math.cos(angle) * Math.min(SPEED, dist);
			pos.y += Math.sin(angle) * Math.min(SPEED, dist);
			
			// enemies spew sounds:
			footstepCounter += deltaT;
			if (footstepCounter > 250) {
				footstepCounter = 0;
				game.level.makeSound(4, new b2Vec2(pos.x * Box2DUtil.INV_SCALING_FACTOR, pos.y * Box2DUtil.INV_SCALING_FACTOR), 0, true, 0.3);
			}
		}
		
		public function postupdate():void {
			if(game.level.debugSprite){
				game.level.debugSprite.graphics.lineStyle(3, 0xFF0000);
				game.level.debugSprite.graphics.drawRect(pos.x - SIZE, pos.y - SIZE, SIZE * 2, SIZE * 2);
			}
		}
		
		public function isEngaged():Boolean {
			if (MathUtil.distanceBetween(pos.x, pos.y, targetX, targetY) > 0.5)
				return true;
			return false;
		}
		
	}

}